Starting after version 1.14.0, we provide release notes through the metainfo file. As such, app stores (like GNOME Software) can show release notes to users.

Human-readable textual output can easily be generated with the following command:

$ appstream-util appdata-to-news /usr/share/metainfo/org.gnome.gnome-commander.metainfo.xml

===================================
gnome-commander 1.14.0
---------------

New features:
 * Selectable default action when drag-n-drop files with the mouse
 * Optional usage of the trash can instead of permanent file deletion (see issue #2)
 * Removed internal file search dialog, instead use external command for file search
 * Name of connected remote server is shown in the directory indicator (see issue #71)
 * New menu entry for (un)selecting only files

Bug fixes:
 * Fixed issue #3  (Mounted devices pluged when Commander is running are not noticed)
 * Fixed issue #5  ("Follow Links" option does not work when copying files)
 * Fixed issue #13 (Directory size not updated while copying)
 * Fixed issue #16 (Start-left-dir doesn't work on '.' (dot directory))
 * Fixed issue #19 (FTP connections are not closed correctly)
 * Fixed issue #28 (Write permissions are given to all users on an FTP server)
 * Fixed issue #33 (Get rid of deprecated gnome-vfs)
 * Fixed issue #39 (Copy fail when selecting a "drive")
 * Fixed issue #41 (Directory not unreferenced correctly from cache when renamed)
 * Fixed issue #45 (Gnome Commander closes when clicking on SMB path \\xxx\dddddd)
 * Fixed issue #46 (Automatic refresh of folder content is not correct)
 * Fixed issue #47 (Duplicate directory when copying over an existing directory)
 * Fixed issue #51 (Move and not copy by default on same filesystem)
 * Fixed issue #52 (Auto refresh when changing permissions etc)
 * Fixed issue #57 (Remote connections: Gnome Commander misreads file ownership)
 * Fixed issue #59 (On ssh connection, to delete a renamed folder/file don't work)
 * Fixed issue #74 (Does not show mounted external drives)
 * Fixed issue #75 (Newly inserted DVD does not show up)
 * Fixed issue #76 (Crash in Gnome Commander when using webDAV SSL)
 * Fixed issue #107 (Wrong parsing of command string)
 * Fixed issue #115 (No error on autogen when flex is missing)

List of developers:
 * Uwe Scholz
 * Mamoru Tasaka
 * Andrey Sokolov
 * Maik Pertermann
 * Philipp Kiemle

New or updated translations:
 * ca (Jordi Mas)
 * cs (Marek Černocký)
 * da (Alan Mortensen, Ask Hjorth Larsen)
 * de (Tim Sabsch, Wolfgang Stöggl)
 * es (Daniel Mustieles, Rodrigo Lledó)
 * eu (Asier Sarasua Garmendia)
 * fi (Jiri Grönroos)
 * hu (Balázs Úr)
 * id (Andika Triwidada, Kukuh Syafaat)
 * pl (Piotr Drąg)
 * pt_BR (Enrico Nicoletto, Matheus Barbosa, Rafael Fontenelle)
 * ro (Daniel Șerbănescu)
 * ru (Andrey Sokolov, Олеся Герасименко)
 * sl (Matej Urbančič)
 * sr (Мирослав Николић)
 * sv (Anders Jonsson, Luna Jernberg)
 * tr (Muhammet Kara)
 * uk (Yuri Chornoivan)
 * zh_CN (Boyuan Yang)

New or updated docs:
 * es (Daniel Mustieles)
 * sv (Anders Jonsson)


===================================
gnome-commander 1.12.3.1
---------------

Bug fixes:
 * Fixed issue #110 (Make check fails on s390x, Thanks to Mamoru Tasaka)

New or updated translations:
 * pl (Piotr Drąg)
 * sv (Anders Jonsson)
 * uk (Yuri Chornoivan)

New or updated docs:
 * sv (Anders Jonsson)

===================================
gnome-commander 1.12.3
---------------

Bug fixes:
 * Fixed issue #108 (Crash after right click on file)
 * File-roller plugin: Add run error handling (Thanks to Andrey Sokolov)

New or updated translations:
 * cs (Marek Černocký)
 * de (Wolfgang Stöggl)
 * hu (Balázs Úr)
 * ru (Andrey Sokolov)

New or updated docs:
 * sv (Anders Jonsson)

===================================
gnome-commander 1.12.2
---------------

Bug fixes:
 * Fixed issue #104 (Segmentation fault when pressing Ctrl+Right / Ctrl+Left / Ctrl+Shift+.)

New or updated translations:
 * es (Daniel Mustieles)
 * id (Andika Triwidada
 * ro (Daniel Șerbănescu)

New or updated docs:
 * sv (Anders Jonsson)

===================================
gnome-commander 1.12.1
---------------

Bug fixes:
 * Fixed issue #12 (Ask for the second time when trying to delete non-empty directory)
 * Fixed issue #97 ("Execute" not shown in file popup menu for executable files)
 * Fixed issue #98 ("Execute" doesn't work on files with space in filename)
 * Fixed issue #55 (Theme does not change in all tabs when applied)
 * Fixed issue #102 (Compilation error when TagLib is not available)
 * Fixed issue #103 (Crash when empty string is given for search)

New or updated translations:
 * pl (Piotr Drąg)
 * pt_BR (Enrico Nicoletto)
 * sr (Мирослав Николић)
 * sv (Anders Jonsson)
 * uk (Yuri Chornoivan)

New or updated docs:
 * sv (Anders Jonsson)

===================================
gnome-commander 1.12.0
---------------

New features:
 * Gnome Commander depends on GIO now. Migration away from GnomeVFS is ongoing
 * Use GIO instead of Gnome-VFS for opening files with default application
 * Use GIO instead of Gnome-VFS for filtering the file list, and on various other parts of the program

Bug fixes:
 * Fixed issue #95 (InternalViewer: Scrolling images via mouse, mouse scroll wheel or keyboard arrow keys)
 * Fixed issue #96 (Segmentation fault when opening file/directory properties using keyboard)
 * Minor memory optimizations

New or updated translations:
 * ca (Jordi Mas)
 * cs (Marek Černocký)
 * da (Ask Hjorth Larsen)
 * de (Mario Blättermann, Stephan Woidowski, Tim Sabsch, Wolfgang Stöggl)
 * eo (Kristjan SCHMIDT)
 * es (Daniel Mustieles)
 * eu (Asier Sarasua Garmendia)
 * fi (Jiri Grönroos)
 * hu (Balázs Meskó, Balázs Úr)
 * id (Andika Triwidada, Kukuh Syafaat)
 * kk (Baurzhan Muftakhidinov)
 * pl (Piotr Drąg)
 * pt_BR (Rafael Fontenelle)
 * ro (Daniel Șerbănescu)
 * sl (Matej Urbančič)
 * sr (Мирослав Николић)
 * sv (Anders Jonsson)
 * tr (Sabri Ünal)
 * uk (Yuri Chornoivan)

New or updated docs:
 * cs (Marek Černocký)
 * de (Mario Blättermann, Stephan Woidowski)
 * es (Daniel Mustieles)
 * sv (Anders Jonsson)

===================================
gnome-commander 1.10.3
---------------

New features:
 * InternalViewer: Show metadata file information by default
 * Minor memory management improvements

Bug fixes:
 * Fixed issue #29 (Migrate deprecated GnomeFileEntry to GtkFileChooserButton)
 * Fixed issue #34 (Get rid of deprecated libgnome and libgnomeui)
 * Fixed issue #65 (Search options: 'copy file name' does not work)
 * Fixed issue #83 (Switch from nautilus-sendto to xdg-email as default send-to command)

New or updated translations:
 * cs (Marek Černocký)
 * de (Wolfgang Stöggl)
 * es (Daniel Mustieles)
 * eu (Asier Sarasua Garmendia)
 * id (Andika Triwidada)
 * id (Kukuh Syafaat)
 * pl (Piotr Drąg)
 * pt_BR (Rafael Fontenelle)
 * pt_BR (Uwe Scholz)
 * sv (Anders Jonsson)
 * uk (Yuri Chornoivan)

New or updated docs:
 * cs (Marek Černocký)
 * es (Daniel Mustieles)

===================================
gnome-commander 1.10.2
---------------

Bug fixes:
 * Fix for compilation error with exiv2 0.27.1 (Thanks to Mamoru Tasaka)

New or updated docs:
 * es (Daniel Mustieles)

===================================
gnome-commander 1.10.1
---------------

New features:
 * Menu entry for (un)selecting files with the same filename suffix
 * Search window can be optionally minimized or moved below the main window

Bug fixes:
 * List of bookmarks is synchronized between Gnome Commander instances
 * Removed gnome-config references, fixing bgo#570733 and issue #27 on GitLab

New or updated translations:
 * ar, bg dz, en_CA, en_GB, ga, hr, ne, rw, sq, vi, zh_TW (Elijah Zarezky)
 * de (Mario Blättermann)
 * es (Daniel Mustieles)
 * hu (Balázs Meskó)
 * pl (Piotr Drąg)
 * pt_BR (Rafael Fontenelle)

New or updated docs:
 * de (Mario Blättermann)
 * es (Daniel Mustieles

===================================
gnome-commander 1.10.0
---------------

New features:
 * Gnome Commander icon and internal viewer icon refreshed
 * Gnome Commander settings are now completely migrated to GSettings under the key `org.gnome.gnome-commander`
 * Settings in `~/.gnome2/gnome-commander` and in `~/.gnome-commander/*` are migrated automatically
 * Script and plugin folder in `~/.gnome-commander` is moved into `~/.config/gnome-commander`

Bug fixes:
 * Various warnings at compile time have been fixed
 * Several code improvements and memory leaks have been fixed

New or updated translations:
 * cs (Marek Cernocky)
 * da (Ask Hjorth Larsen)
 * de (Mario Blättermann)
 * de (Tim Sabsch)
 * es (Daniel Mustieles)
 * es (Piotr Drąg)
 * hu (Balázs Úr)
 * id (Kukuh Syafaat)
 * pl (Piotr Drąg)
 * pt_BR (Isaac F. Ferreira Filho)
 * pt_BR (Rafael Fontenelle)
 * sr (Мирослав Николић)
 * sr@latin (Мирослав Николић)
 * sv (Anders Jonsson)

New or updated docs:
 * cs (Marek Cernocky)
 * de (Mario Blättermann)
 * de (Tim Sabsch)
 * es (Daniel Mustieles)
 * es (Piotr Drąg)
 * sv (Anders Jonsson)

===================================
gnome-commander 1.8.1
---------------

New features:
 * Store the size of the options dialog when closing itself
 * Remove unnecessary border lines from the options dialog tabs (thanks to Elijah)
 * Removed python support completely

Bug fixes:
 * Fix simple script system for file names with spaces
 * Fixed bgo#785505: Problem when compiling GCMD with flex 2.6.4

New or updated translations:
 * cs (Marek Cernocky)
 * da (Ask Hjorth Larsen)
 * de (Mario Blättermann)
 * es (Daniel Mustieles)
 * hu (Balázs Meskó)
 * id (Kukuh Syafaat)
 * pl (Piotr Drąg)
 * pt_BR (Isaac F. Ferreira Filho)
 * sr (Мирослав Николић)
 * sr@latin (Мирослав Николић)
 * sv (Anders Jonsson)

New or updated docs:
 * cs (Marek Cernocky)
 * de (Mario Blättermann)
 * es (Daniel Mustieles)

===================================
gnome-commander 1.8.0
---------------

New features:
 * Quick search can be activated by just typing a letter, adjustable in the options tab
 * Option for saving/not saving the command line history on exit
 * Option for saving/not saving the search history on exit
 * Added a settings option for deciding if the terminal window should stay open when a command finishes
 * [build] Don't use gnome-autogen.sh anymore (Many thanks to Philip Withnall and David King)
 * [build] Translations are now handled by upstream gettext instead of intltool
 * [build] New documentation infrastructure: Use yelp-tools instead of gnome-doc-utils

Other changes:
 * Increased minimum GTK version from 2.8.0 to 2.18.0
 * Code cleanup (Thanks to Mamoru and Andreas for contributing)

Bug fixes:
 * [build] Python is now found at build time, too, when its version is equal to or higher than 3.x

New or updated translations:
 * ca (Jordi Mas)
 * cs (Marek Černocký)
 * de (Mario Blättermann)
 * eo (Kristjan Schmidt)
 * es (Daniel Mustieles)
 * fi (Jiri Grönroos)
 * hu (Balázs Úr)
 * id (Kukuh Syafaat)
 * pl (Piotr Drąg)
 * pt_BR (Rafael Fontenelle)
 * sl (Matej Urbančič)
 * sr (Мирослав Николић)
 * sr@latin (Мирослав Николић)
 * sv (Anders Jonsson)

New or updated docs:
 * cs (Marek Černocký)
 * de (Mario Blättermann)
 * es (Daniel Mustieles)

===================================
gnome-commander 1.6.4
---------------

Bug fixes:
 * Fixed problem bgo#779574 (Other favourite apps settings not saved)
 * Fixed problem bgo#619112 (Internal-viewer by default display incorrect code pages)

New or updated translations:
 * cs (Marek Černocký)
 * de (Mario Blättermann)
 * eu (Inaki Larranaga Murgoitio)
 * hu (Balázs Úr)
 * id (Andika Triwidada)
 * pl (Piotr Drąg)
 * pt_BR (Rafael Fontenelle)
 * sr (Мирослав Николић)
 * sr@latin (Мирослав Николић)
 * sv (Anders Jonsson)

New or updated docs:
 * cs (Marek Černocký)
 * de (Mario Blättermann)
 * es (Daniel Mustieles)

===================================
gnome-commander 1.6.3
---------------

Bug fixes:
 * libunique (sometimes called only 'unique') is now optional via configure option

New or updated translations: 
 * cs (Marek Černocký)
 * es (Daniel Mustieles)
 * pl (Piotr Drąg)
 * pt_BR (Rafael Fontenelle)
 * ru (Stas Solovey)
 * sr (Мирослав Николић)
 * sr@latin (Мирослав Николић)

New or updated docs:
 * cs (Marek Černocký)
 * de (Mario Blättermann)
 * es (Daniel Mustieles)

===================================
gnome-commander 1.6.2
---------------

Bug fixes:
 * Fixed problem bgo#398734 (Color of marked files does not change when using theme colors)
 * Device list entry width is set equal to the longest string in the list
 * Fixed a bug in advance rename tool when utilizing METATAGS
New features:
 * Disk free space label is shown in status bar if device list isn't shown (works after restarting gcmd)
 * Shortcut can be assigned for:
   - Moving the cursor up or down ("Move cursor one step up/down")
   - Viewing bookmarks of current device ("Show bookmarks of current device")
New or updated translations: 
 * hu (Balázs Meskó)
 * de (Mario Blättermann)
 * pl (Piotr Drąg)
 * sr (Мирослав Николић)
 * sr@latin (Мирослав Николић)
New or updated docs:
 * cs (Marek Černocký)

===================================
gnome-commander 1.6.1
---------------

Bug fixes:
 * Fixed problem bgo#638174 (Selection background color not applied when using custom colors)
 * Fixed problem bgo#773063 (Compiles with gcc6 -Werror=format-security, Thanks to Mamoru Tasaka)

New or updated docs:
       cs (Marek Černocký)

===================================
gnome-commander 1.6.0
---------------

Bug fixes:
 * Fixed problem bgo#671616 (Right-Mouse popup menu is displayed in wrong position, Thanks to Puux)
 * Fixed problem bgo#683087 (Crash opening properties window on certain objects, Thanks to Puux)
 * Fixed problem bgo#742752 (Made options dialog resizable and added scrollbars)
 * Preserve focused file after renamed with AdvRenDialog (Thanks to Martin Mocko)
 * Fixed problem bgo#767158 (Shortcuts stop working after changing layout)
 * Fixed string escaping for directories with ampersand (see bgo#769309)
 * Fixed problem bgo#770062 (Memory leak in GnomeCmdPlainPath, Thanks to Eric)
 * Fixed problem bgo#770063 (Memory leak in get_string_pixel_size, Thanks to Eric)

New features:
 * Always reopen the tab which was previously closed in the options dialog
 * Samba support is now optionally available via configure option
 * Configurable command for sending files to a preferred application
 * Button 'Edit files' accepts more than one selected file at the same time
 * Device buttons and device list entries act as 'home buttons' for that device when it is already active
 * Copy directory path to clipboard after right click on dir-indicator (Thanks to Puux)
 * Show/hide mainmenu can be set as keyboard shortcut now (Thanks to Puux)
 * Simple plug-in system for file context menu (Thanks to Puux)
 * Display of application icons in the "Open With" popup menu (Thanks to Puux)
 * Write bookmark changes immediately to file, Sync bookmarks between all instances (Thanks to Puux)
 * Storage of options is done in the dconf database now instead of a gnome-config file (see bgo#570733)
 * Devices and fav-apps are now stored within the GKeyFile format
 * File Roller plugin can use patterns of strftime when creating the archive name
 * Started usage of google test framework for unit tests
 * New colour theme 'Winter'
 * Code cleanup
Other changes:
 * Removed "Open folder" command in popup menu and user actions
New or updated translations: 
       bs (Samir Ribic)
       ca (Jordi Mas)
       cs (Marek Černocký)
       de (Mario Blättermann, Wolfgang Stöggl)
       es (Daniel Mustieles)
       eu (Inaki Larranaga Murgoitio)
       fi (Lasse Liehu)
       fr (Alexandre Franke)
       hu (Balázs Meskó, Balázs Úr)
       id (Andika Triwidada)
       lt (Zygimantus)
       nb (Kjartan Maraas)
       oc (Cédric Valmary)
       pl (Piotr Drąg)
       pt (Pedro Albuquerque)
       pt_BR (Rafael Fontenelle)
       ro (Jobava)
       sk (Dušan Kazik, Tibor Kaputa)
       sl (Matej Urbančič)
       sr (Мирослав Николић)
       sr@latin (Мирослав Николић)
       sv (Anders Jonsson, Josef Andersson)
       tr (Necdet Yücel)
New or updated docs:
       cs (Daniel Mustieles, Marek Černocký)
       de (Christian Kirbach, Mario Blättermann)
       el (Dimitris Spingos, Maria Mavridou)
       es (Daniel Mustieles)

===================================
gnome-commander 1.4.9
---------------
Bug fixes:
 * Fixed bgo#764306 (Spelling mistake and wrong words in strings, thanks to Anders Jonsson)
 * New or updated translations:
       cs (Marek Černocký)
       de (Mario Blättermann)
       es (Daniel Mustieles)
       hu (Balázs Meskó)
       hu (Balázs Úr)
       hu (Gábor Kelemen)
       id (Andika Triwidada)
       pl (Piotr Drąg)
       pt (Tiago Santos)
       ro (Jobava)
       sk (Dušan Kazik)
       sr (Мирослав Николић)
       sr@latin (Мирослав Николић)
       sv (Anders Jonsson)
* New or updated docs:
       cs (Marek Černocký)
       de (Mario Blättermann)
       es (Daniel Mustieles)

===================================
gnome-commander 1.4.8
---------------

Bug fixes:
 * Fixed problem bgo#761580 (Support gcc6 -Werror=format-security, thanks to Mamoru Tasaka)
 * New or updated translations:
       cs (Marek Černocký)
       de (Wolfgang Stöggl)
       pl (Piotr Drąg)
       pt (Pedro Albuquerque)
       pt_BR (Gustavo Marques)
       oc (Cédric Valmary)
* New or updated docs:
       cs (Marek Černocký)
       de (Mario Blättermann)

===================================
gnome-commander 1.4.7
---------------

Bug fixes:
 * Fixed problem bgo#745454 (Segmentation fault after find files, thanks to Mamoru Tasaka)
 * Fixed problem bgo#749869 (Segfault on the second search, thanks to Mamoru Tasaka)
 * Fixed problem bgo#734032 (Clicking on .png file looks at wrong MIME type, thanks to Mamoru Tasaka)
 * New or updated translations:
       oc (Cédric Valmary)
* New or updated docs:
       cs (Marek Černocký)
 
===================================
gnome-commander 1.4.6
---------------

Bug fixes:
 * Fixed problem bgo#747771 (appdata.xml file is not being translated, thanks to Dominique Leuenberger)
 * Fixed problem bgo#746003 (crash on opening property dialog on ftp-directory with "odd" uid)
 * Fixed problem bgo#748869 (crash when searching two times consecutively)
 * Fixed problem bgo#653573 (Passwords store in plain text in ./gnome-commander/connections)
 * Fixed problem bgo#742752 (Made options dialog resizable and added scrollbars)
 * New or updated translations:
       el (Maria Mavridou)
       pt (Pedro Albuquerque)
       bs (Samir Ribic)
 * New or updated docs:
       cs (Marek Černocký)
       el (Maria Mavridou)
       
===================================
gnome-commander 1.4.5
---------------

Bug fixes:
 * Fixed problem bgo#741316 (Appdata missing in POT) 
 * Fixed problem bgo#742716 (Option --start-right-dir crashes gnome-commander)
 * Removed python-2.6 support from gentoo ebuild
 * New or updated translations:
       hu (Balázs Úr)
       id (Andika Triwidada)
       sr (Мирослав Николић)
       sr@latin (Мирослав Николић)
New or updated docs:
    cs (Marek Černocký)

===================================
gnome-commander 1.4.4
---------------

Bug fixes:
 * Fixed problem bgo#571495 (Migrated from gnome_execute_shell to g_spawn_async)
 * Fixed problem bgo#737088 (Support for user's terminal different from gnome-terminal)
New or updated translations: 
    cs (Marek Černocký)
    de (Benjamin Steinwender)
    eu (Inaki Larranaga Murgoitio)
    fi (Lasse Liehu)
    id (Andika Triwidada)
    sr (Мирослав Николић) (sr@latin)
    sr@latin (Мирослав Николић)
New or updated docs:
    cs (Marek Černocký)
    es (Daniel Mustieles)

===================================
gnome-commander 1.4.3
---------------

Bug fixes:
 * Fixed problem bgo#731557 (Crash when drag 'n drop objects via mouse)
New or updated translations: 
    cs (Marek Černocký)
    de (Benjamin Steinwender)
    eu (Inaki Larranaga Murgoitio)
    fi (Lasse Liehu)
New or updated docs:
    cs (Marek Černocký)

===================================
gnome-commander 1.4.2
---------------

Bug fixes:
 * Fixed Gentoo problem #509574 (Switched from python-r1 to python-single-r1 in ebuild)
 * Fixed problem bgo#367949 (Corrected async_xfer_callback-results for moving folders)
 * Fixed problem bgo#598161 (Selecting text in internal viewer on lines with TANew features:
 * Text selection in int. viewer works on lines with TAB characters (Thanks to Jan Vleeshouwers)
New or updated translations: 
    cs (Marek Černocký)
    el (Dimitris Spingos)
    sr (Мирослав Николић)
    sr@latin (Мирослав Николић)

===================================
gnome-commander 1.4.1
---------------

Bug fixes:
 * Fixed problem bgo#641842 (use poppler-glib instead of poppler internal API)
 * Fixed problem bgo#726682 (Fix for undefined reference to vtable)
 * Support for utf8 encoded creation and modification dates in document metadata
 * Moved Search, Quick Search and Enable Filter from Edit to File menu
New or updated translations: 
    cs (Marek Černocký)
    es (Daniel Mustieles)
    fr (Alexandre Franke)
    id (Andika Triwidada)
    pt_BR (Rafael Ferreira)
    sl (Matej Urbančič)
New or updated docs:
    cs (Marek Černocký)
    es (Daniel Mustieles)

===================================
gnome-commander 1.4.0
---------------

Bug fixes:
 * Fixed problem bgo#377463 (mkdir dialog loses focus)
 * Fixed problem bgo#492479 (file replace prompt must show date and size of files)
 * Fixed problem bgo#617140 (GNOME Goal: Use accessor functions instead direct access)
 * Fixed problems bgo#632064, bgo#632208, bgo#633107, bgo#633167, bgo#633331, bgo#634972, bgo#637873, bgo#638059 (bugs in gnome-commander-help.master.po)
 * Fixed problem bgo#660043 (shortcut ALT+DOWN not documented)
 * Fixed problem bgo#660268 (remember directory history between sessions)
 * Fixed problem bgo#667080 (delete confirmation defaults to YES/OK)
 * Fixed Ubuntu problem #117226 (bookmarks unification)
 * Fixed problem with right mouse button selection not being precise
 * Fixed problem bgo#696227 (detect and support libgsf >= 1.14.26)
 * Fixed problem bgo#684527 (Fixed typos in strings)
 * Fixed problem bgo#660063 (define ALT+DOWN binding as user definable: view.dir_history)
 * Fixed problem bgo#642178 (lock tabs for prev/next buttons)

New features:
 * Support for tabs
 * Revamped bookmarks dialog
 * Revamped file properties dialog
 * One instance mode
 * New colour theme: green tiger
 * User defined LS_COLORS colours
 * Possibility to select/deselect files only
 * Support for automatic width counters in advanced file rename
 * Enhanced file name matching in quick search
 * Open terminal with administrator privileges 
 * Prompt to confirm drag & drop operations
 * Right click popup menu for copying in internal viewer
 * --config-dir command line option for customized location of config files
 * Several speed improvements including C++ rework and code cleanups
 * New python plugin: 'apply_patch'
 * Dropped broken MIME type configuration
 * Dropped support for cvs plugin
 * New key bindings:
      CTRL+T         Open directory in a new tab (replaces the old Multi-Rename-Tool binding)
      CTRL+W         Close current tab
      CTRL+SHIFT+W   Close all tabs
      CTRL+TAB       Switch to the next tab
      CTRL+SHIFT+TAB Switch to the previous tab
      SUPER+1        Change left connection
      SUPER+2        Change right connection
 * New or updated docs:
       cs (Marek Černocký)
       de (Mario Blättermann, Niklas Mattisson, Piotr Drąg)
       es (Daniel Mustieles, Jorge González)
       el (Dimitris Spingos)
       fr (Alexandre Franke, Bruno Brouard, Claude Paroz)
       ru (Aleksej Kabanov, Radik Usupov)
       sl (Matej Urbančič)
 * New or updated translations:
       ca (Gil Forcada)
       cs (Marek Černocký, Petr Kovar, Piotr Eljasiak)
       da (Ask H. Larsen)
       de (Mario Blättermann)
       dz (Daniel Mustieles)
       en_GB (Piotr Eljasiak)
       eo (Kristjan SCHMIDT)
       el (Dimitris Spingos)
       es (Daniel Mustieles, Jorge González)
       eu (Inaki Larranaga Murgoitio, Piotr Eljasiak)
       fr (Bruno Brouard, Claude Paroz, Laurent Coudeur)
       hu (Balázs Úr, Gabor Kelemen)
       id (Andika Triwidada)
       it (Alberto Bertoncini, Piotr Eljasiak) 
       ja (Jiro Matsuzawa, OKANO Takayoshi, Piotr Eljasiak, Takayuki KUSANO)
       ko (Sewon Jang)
       nb (Kjartan Maraas)
       nl (Hannie Dumoleyn, Piotr Eljasiak, Wouter Bolsterlee)
       pl (Piotr Eljasiak)
       pt_BR (Adorilson Bezerra, Gabriel F. Vilar, Juan Diego Martins da Costa Cruz, 
       	      Mateus Zenaide, Michel Recondo, Piotr Eljasiak)
       ro (Daniel Șerbănescu, Lucian Grijincu)
       ru (Aleksej Kabanov, Dmitriy Kodanev, Radik Usupov, Yuri Kozlov)
       sl (Martin Srebotnjak, Matej Urbančič)
       sr (Мирослав Николић )
       sr@latin (Мирослав Николић)
       sv (Daniel Nylander, Piotr Eljasiak)
       th (Akom Chotiphantawanon)
       uk (Maxim V. Dziumanenko)
       zh_CN (Aron Xu, lainme)
       TW (RayCherng Yu zh)

===================================
gnome-commander 1.2.8.17
---------------

Bug fixes:
 * Fixed problem bgo#721132 (Support build with -Werror=format-security)
 * Updated GCMD home page location
 * New or updated translations: 
       es (Daniel Mustieles), 
       id (Andika Triwidada), 
       pt_BR (Adorilson Bezerra)


===================================
gnome-commander 1.2.8.16
---------------

Bug fixes:
 * Fix for gcc-4.7 compiling problem
 * Fix for bgo#705724 (poppler >= 0.24)
 * Fix for bgo#676303 (poppler >= 0.20.0)
 * New or updated docs: 
       de (Mario Blättermann), el (Dimitris Spingos), fr (Bruno Brouard)
 * New or updated translations: 
       da (Ask H. Larsen), de (Mario Blättermann, Uwe Scholz), 
       el (Dimitris Spingos), fr (Bruno Brouard), hu (Balázs Úr),
       id (Andika Triwidada), pt_br (Adorilson Bezerra, Juan Diego Martins
       da Costa Cruz), ru (Aleksej Kabanov), sl (Martin Srebotnjak), 
       th (Akom Chotiphantawanon)


===================================
gnome-commander 1.2.8.15
---------------

Bug fixes:
 * Fixed problem #65372 (missing links in gcmd-1.2.8 documentation)
 * New or updated docs: cs, de, es, fr
 * Updated translations: eo, es, sl


===================================
gnome-commander 1.2.8.14
---------------

Bug fixes:
 * Fixed problem #621756 (custom port for ftp is not saved)
 * Fixed problem #657780 (bugs in nl.po)


===================================
gnome-commander 1.2.8.13
---------------

Bug fixes:
 * Fixed problem #646871 (crash on file properties when connected to FTP)


===================================
gnome-commander 1.2.8.12
---------------

Bug fixes:
 * Fixed problem #618214 (crash when cancel a search)
 * Fixed problem #640387 (yet another fix for deprecated python modules: md5, sha1)
 * Fixed problem #649375 (bookmarks not updated for newly added ones)
 * Fixed problem with mkdir permissions


===================================
gnome-commander 1.2.8.11
---------------

Bug fixes:
 * Fixed problem #639243 (misleading docs for F2 shortcut)
 * Fixed problem #640387 (usage of deprecated python modules: md5, sha1)
 * Fixed problem with starting GNOME Commander as root
 * Fixed problem with Traditional Chinese translation

New features:
 * Support for backward/forward mouse buttons


===================================
gnome-commander 1.2.8.10
---------------

Bug fixes:
 * Fixed problem #448941 (numeric keypad arrows don't work in the main window)
 * Fixed problem #620275 (add menu item to copy full path and file name to clipboard)
 * Fixed problem #637501 (advrename: metatag popup menu shows wrong items)
 * Fixed problem with toggling path/basename/filename selections in copy/move dialogs
 * Fixed problem with searching path for devices
 * Updated translations: de


===================================
gnome-commander 1.2.8.9
---------------

Bug fixes:
 * Fixed problem #352024 (F10 key doesn't work)
 * Fixed problem #631243 (advrename $c(width) regression)

New features:
 * Support for shell-style wildcards in quick search


===================================
gnome-commander 1.2.8.8
---------------

Bug fixes:
 * Fixed problem #610764 (menu item won't stay checked)
 * Fixed problem #626469 (add support for other su-like programs: xdg-su, gnomesu)
 * Fixed problem with broken Spanish translation


===================================
gnome-commander 1.2.8.7
---------------

Bug fixes:
 * Fixed problem #540438 (no GUI message if meld cannot be executed)
 * Fixed problem #616367 ("File not found" dialog after startup)
 * Fixed problem #620650 (buffer overflow in load_fav_apps())
 * Fixed problem #622456 (do not build plugins as shared library objects)
 * Fixed problem with editing options for favourite apps and devices


===================================
gnome-commander 1.2.8.6
---------------

Bug fixes:
 * Fixed problems #600292, 612685 (crashes when double-clicking on a bookmark)
 * Fixed problem #602795 (file content search)
 * Fixed problem #609912 (build error with --as-needed)
 * Fixed problem #616891 (build error on RHEL 5.5)

New features:
 * New translations: ko


===================================
gnome-commander 1.2.8.5
---------------

Bug fixes:
 * Fixed problem #604558 (cursor lost/placed in wrong position)
 * Fixed problem #604904 (build error on OpenSolaris)
 * Fixed problem #609342 (do not show mtime for '..')
 * Fixed problem with editing connections to Windows network
 * Fixed problem with nonexistent user actions


===================================
gnome-commander 1.2.8.4
---------------

Bug fixes:
 * Fixed problem #602916 (not working menu entry)
 * Fixed problem #603301 (crash when cancelling symlink creation by ESC)
 * Fixed Ubuntu problem #369818 (incorrect sorting by size in panel)
 * Fixed problem with not working keypad enter in copy/move dialog
 * Fixed problem with stalled keyboard after ALT+1/2 with hidden device list


===================================
gnome-commander 1.2.8.3
---------------

Bug fixes:
 * Fixed problem #541891 (file names with % in advanced file rename tool)
 * Fixed problem #581645 (uncomfortable quick search)
 * Fixed problem #596768 (build warnings for python)
 * Fixed problem #596973 (documentation build error)
 * Fixed problem #597144 (missing call to pclose)
 * Fixed problem #597233 (validating of doc translations)
 * Fixed problem #597890 (wrong arguments passed to meld)
 * Fixed problem #598278 (memory leak)


===================================
gnome-commander 1.2.8.2
---------------

Bug fixes:
 * Fixed problem #591944 (permissions set to 000 after chmod)
 * Fixed problem #595097 (build error for poppler >= 0.11.3)
 * Fixed debian problem #438884 (wrong device label when switching panels with CTRL+U)
 * Fixed problem with broken file icon after renaming a symbolic link


===================================
gnome-commander 1.2.8.1
---------------

Bug fixes:
 * Fixed problem #587325 (crash in a clean chroot environment)
 * Fixed problem #589108 (build error on openSUSE)
 * Fixed problem #591206 (crash while sysconf() on FreeBSD)
 * Fixed problem with $c(16) counter formatting in advanced file rename templates


===================================
gnome-commander 1.2.8
---------------

Bug fixes:
 * Fixed problem #375357 (crash when cancelling calculation of dir properties)
 * Fixed problem #536446 (file name not focused for in-place renaming)
 * Fixed problem #539812 (crash when deleting files: broken it.po)
 * Fixed problem #548947 (non-UTF8 locale date problem)
 * Fixed problem #548948 (crash when home directory contains non-UTF8 characters)
 * Fixed problem #548961 (support for input method when rename or quicksearch)
 * Fixed problem #554586 (AC_PROG_CXX macro problem)
 * Fixed problem #554598 (GNOME Goal: LINGUAS)
 * Fixed problem #556664 (bookmarks can not be saved for mounted devices)
 * Fixed problem #556836 (pane scrolling when moving between panes)
 * Fixed problem #567404 (crash when INSERT pressed over subdir)
 * Fixed problem #567506 (slow startup for systems with many users)
 * Fixed problem #570727 (usage of deprecated gnome_url_show)
 * Fixed problem #571239 (replacing obsoleted GnomeColorPicker with GtkColorButton)
 * Fixed problem #571247 (replacing obsoleted GnomePixmap with GtkImage)
 * Fixed problem #571558 (replacing deprecated GNOME_STOCK_* buttons with GTK_STOCK_* counterparts)
 * Fixed problem #576174 (case insensitive file name sorting in non en_US.utf8 locale)
 * Fixed problem #579633 (accessing administrator privileges with gksudo)
 * Fixed problem #583135 (disabled 'Go to' button in search dialog)
 * Fixed problem #583711 (crash when pressing ESC in bookmark dialog)
 * Fixed problem #584727 (wrong positioning of file popup menu)
 * Fixed problem with setting equal pane size in horizontal mode
 * Fixed problem with refreshing MIME information after file renaming

New features:
 * Support for PDF metatags in advanced file rename templates
 * Revamped advanced file rename tool (regex backreferences ('\number'), profiles,
   upper/lowercase conversion, blanks trimming and much more)
 * Support for metadata tags in internal viewer
 * Support for single-click open mode
 * Support for row alternate background in colour themes
 * New colour theme: cafezinho
 * New or updated docs: de, en, es
 * New or updated translations: ar, cs, de, es, eu, fr, it, ja, pl, pt_BR, sl, sv
 * New key bindings:
      CTRL+E         Open the history list for the command line
 * New internal viewer key bindings:
      T              Show metadata tags (replaces the old E)
      ALT+ENTER      Show metadata tags


===================================
gnome-commander 1.2.7
---------------

Bug fixes:
 * Fixed problem #522430 (quick search for files starting with uppercase)
 * Fixed problem #532615 (file operations on wrong file)
 * Fixed problem #538806 (quick search in root dir)
 * Fixed problem #539753 (build error on Solaris)
 * Fixed problem #541404 (update of host names)
 * Fixed problem with file sorting in advanced file rename tool
 * Build fixes

New features:
 * Support for all GnomeVFS network protocols (including SSH+FTP and WebDAV)
 * User defined shortcuts to arbitrary programs
 * Copying selected URIs to clipboard with ALT+click on toolbar button
 * Revamped search dialog
 * Revamped transfer progress dialog
 * Updated help docs
 * New or updated translations: cs, de, es, fr, it, ja, oc, pl, pt_BR


===================================
gnome-commander 1.2.6
---------------

Bug fixes:
 * Fixed problem #392959 (dynamically changing user to root)
 * Fixed problem #496150 (scrolling with mouse wheel)
 * Fixed problem #499761 (search window cleared when column sorted)
 * Fixed problem #499764 (multiple selection problem)
 * Fixed problem with sorting of UTF-8 encoded file names
 * Fixed problem with copying files to symlinked directories
 * Fixed problem with full file path  while copying/moving to mounted devices

New features:
 * Root Mode for starting GNOME Commander with administrator privileges
 * GUI for keyboard shortcuts management
 * Open the current location in Nautilus file manager
 * Multi-Rename-Tool - new $x and $X placeholders for random hexadecimal numbers
 * Revamped search dialog
 * Support for <super>, <hyper> and <meta> modifiers (since GTK+ 2.10)
 * Updated help docs
 * New or updated translations: cs, de, en_GB, es, eu, fi, fr, hu, it, oc, pl, sl
 * New key bindings:
      SUPER+F        Search files


===================================
gnome-commander 1.2.5
---------------

Bug fixes:
 * Fixed problem #345314 (cursor not staying on file while renaming)
 * Fixed problem #353889 (disappearing files after failed move (F6))
 * Fixed problems #346286, #424447, #447882, #467058 (crash when using regex in renaming tool)
 * Fixed problems #365227 and #446361 (build issues on Solaris)
 * Fixed problem #424159 (column sort problem)
 * Fixed problem #434545 (Debian bug #421480: HUGE icons for device icons)
 * Fixed problem #447415 (inability to launch executables)
 * Fixed problem #448942 (SHIFT+ENTER: running a command in a separate terminal)
 * Fixed problem #449137 (renamed directories not accessed by name)
 * Fixed problem #468685 (crash in python module)
 * Fixed problem #490431 (view files with name containing '%')
 * Fixed problem #508565 (improper utf-8 handling in advanced file rename tool)
 * Fixed problem #510567 (failed assert when deleting dir)
 * Fixed problem when creating ~/dir
 * Fixed problem with updating of internal viewer status bar
 * Fixed crash when creating dir with absolute path on SMB share
 * Fixed crash when moving file with % in the name
 * Fixed problem with sporadically lost cursor in file pane
 * Fixed problem with mounting of devices with spaces in the name
 * Fixed problem with history of advrename templates
 * Build fixes

New features:
 * Support for APE, FLAC and Vorbis metatags in advanced file rename templates
 * Support for Exif makernotes metatags in advanced file rename templates
 * Support for file metatags in advanced file rename templates
 * Metadata tags in file properties dialog
 * Use the GNOME authentication manager for user's security credentials
 * Open terminal in the current directory
 * Default GNOME theme icons for home, SMB and FTP locations
 * User defined shortcuts to bookmarks
 * Send files via email or instant messenger (using nautilus-sendto)
 * Updated help docs
 * New or updated translations: ar, bg, cs, de, dz, eo, es, eu, fr, oc, pl, pt_BR, ro, sl, sv
 * New key bindings:
      CTRL+LEFT/RIGHT Copying the current working directory from the active
                      filelist to the inactive one
      CTRL+N          Open new connection to remote server (replaces the old CTRL+G)


===================================
gnome-commander 1.2.4
---------------

Bug fixes:
 * Fixed problem with opening dirs by intviewer
 * Fixed problem with editing dirs by gcmd
 * Fixed problem #351952 (crash while doing a content search)
 * Fixed problem #352253 (scrolling behaviour of the viewer)
 * Fixed problem #360175 (crash while entering a dir with %)
 * Fixed problem #371948 and #388970 (file path not escaped)
 * Fixed problem #412162 (build with --enable-python=no)
 * Build fixes

New features:
 * Support for python plugins
 * New python plugins:
      md5sum         Create MD5 (128-bit) checksum
      sha1sum        Create SHA-1 (160-bit) checksum
 * Support for OLE and ODF metatags in advanced file rename templates
 * User defined shortcuts (via configuration file)
 * SMB authentication
 * Displaying total size of files in selected subirs
 * 'cd -' for changing to the previous working directory
 * More intuitive usage of diff tool
 * Directory synchronizing
 * Creating directories 'mkdir -p' like
 * Updated help docs
 * New or updated translations: ar, bg, cs, dz, en_GB, fr, it, oc, pl, sl, sv
 * New key bindings:
      CTRL+\         Go to the root directory
      CTRL+`         Go to the home directory
      CTRL+5         Create MD5 (128-bit) checksum
      CTRL+SHIFT+C   Copy selected file names to clipboard


===================================
gnome-commander 1.2.3
---------------

Bug fixes:
 * Fixed problem #384752 (wrong permissions for new dirs)


===================================
gnome-commander 1.2.2
---------------

Bug fixes:
 * Fixed problem with symlink creation for multiple file selection
 * Fixed problem with grouping of file size digits
 * Fixed problem with SMB UNC handling
 * Fixed problem #367744 (filename not correctly displayed)
 * Fixed problem #374282 (searching with recursive symlinks)
 * Fixed problem #377706 (selecting files with SHIFT+PGDN)

New features:
 * Support for ID3 metatags in advanced file rename templates
 * Updated help docs
 * New or updated translations: ar, en_GB, es, fi, it, pl, sv
 * New key bindings:
      CTRL+SHIFT+=   Set both panels equal


===================================
gnome-commander 1.2.1
---------------

Bug fixes:
 * Fixed problem with scrollkeeper database update
 * Fix for crash when cmd dir indicator is empty
 * Fixed problem with refreshing after chown or chmod
 * Fixed problem #333898 (deprecated icon suffix in desktop file)
 * Fixed problem #347561 (plugin directory set incorrectly)
 * Fixed problem #347817 (incorrect use of Makefile linker flags)

New features:
 * Support for archives (gz,bz2,zip,lha,rar,jar,7-zip,zoo,deb,rpm) via FileRoller plugin
 * New python-like indices for advanced file rename templates
 * Support for Exif and IPTC metatags in advanced file rename templates
 * Fast access to advrename template placeholders
 * In-place rename (SHIFT+F6)
 * Revamped application menus
 * Saving window state across sessions
 * "Find" feature for internal viewer
 * New icon for internal viewer
 * Updated help docs
 * New or updated translations: ca, cs, de, el, en_GB, es, eu, fi, hu, it, ne, pl, ru, sv, vi
 * New key bindings:
      CTRL+SHIFT+H   Toggle hidden files on/off


===================================
gnome-commander 1.2.0
---------------

Bug fixes:
 * Fixed problem #171051 (crashes on search with non-existent path)
 * Fixed problem with the lack of gnome menu entry
 * Fixed a crash when viewing SMB connections
 * Fixed problem #309877 (strange artifacts with horizontal scrolling)
 * Fixed problem #332258 (left/right start directory parameter)
 * Fixed problem #332261 (exec_prefix not properly parsed during configure/makefiles)
 * Fixed problem #336649 (permission numbers presentation)
 * Fixed problem with crashes when using broken or non-matching regex pattern in advrename

New features:
 * Monitoring of mounted volumes
 * Rewritten internal viewer
 * External tools and Exif/IPTC tags viewer for internal viewer
 * Zooming for internal viewer
 * Text selection for internal viewer
 * Revamped toolbar layout
 * Options for controlling copy and move overwriting
 * Copying selected full file paths with SHIFT+click on toolbar button
 * Better handling the change of the column sorting key
 * Initial doc framework
 * New or updated translations: de, es, eu, hu, pl, ro, ru, sl, sv, vi
 * New key bindings:
      SHIFT+F3       Internal viewer
      ALT+F3         External viewer
      ALT+letters    Quick search
      CTRL+SHIFT+A   Deselecting all files


===================================
gnome-commander 1.1.7
---------------

Bug fixes:
 * Fixed crash when trying to copy the currently selected files
 * Fixed filename escaping
 * Fixed CTRL+ALT+letter bad responsiveness when typing too fast
 * Fixed debian bug #288933 (amd64/gcc-4.0 compiling errors)
 * Fixed problem #138933 (infinite recursion when drag'n'dropping a directory to it self)
 * Fixed problem with the disconnect button not behaving correctly when connecting to ftp-servers
   and being in supermount mode
 * Fixed update after renaming without FAM

New features:
 * New GNOME Commander logo
 * Added internal F3 viewer
 * Copying selected filename(s) to clipboard
 * Inserting selected file full path to the cmdline when pressing CTRL+SHIFT+ENTER
 * Multi-Rename-Tool - new $g placeholder for grandparent dir
 * Toolbar buttons (cut,copy and paste) are now sensitive to the current state
 * Manage Bookmarks dialog is now accessible also via the bookmarks shortcut
 * New or updated translations: el, en_CA, en_GB, eu, ga, hu, nb, ne, no, pa, pt_BR, rw, uk, zh_TW
 * New key bindings:
      CTRL+M        Multi-Rename-Tool
      CTRL+SHIFT+.  Copying the current working directory from the active file-list to the inactive one
      CTRL+=        Select all files
      CTRL+-        Unselect all files
      =             Select files using a pattern


===================================
gnome-commander 1.1.6
---------------

Bug fixes:
 * Fixed crash when navigating back in the history and then entering
   another dir.
 * Fixed ftp-quick-connect problems.
 * The quick-search function can now also be started by typing capital
   letters.
 * CTRL+ALT no longer needs to be used to activate quick-search when the
   cmdline is hidden.

New features:
 * Updated the cvs-plugin so that it can be used to diff and log files.
 * Changed to using bold text instead of underlined in the dir-indicator when
   focused by the mouse cursor.
 * Made the cwd label selectable (the one left of the cmdline).
 * Removed the 'Save Position' menu item. Size and position are now saved
   automatically instead.
 * Sorting column and direction is now remembered.
 * Added button to the directory indicator to popup the directory history.
 * Added history to the select and unselect by pattern dialogs.
 * New key bindings:
      F2            Open the rename dialog (replaces old refreshing the active file list)
      CTRL+.        Copy the cwd from the inactive file-list to the active one
      SHIFT+F10     Bring up the file context menu (the windows menu key also works)


===================================
gnome-commander 1.1.5
---------------

Bug fixes:
 * The ext-column is now hidden when the extension is only showed together
   with the filename.
 * Fixed unnecessary redraws of the file-list when dragging files over it.
 * Fixed problem with ftp-connections that didn't disappear from the
   connection toolbars when disconnected.
 * The program no longer tries to center itself on the desktop.
 * Fixed problems when renaming directories.

New features:
 * The dir-indicator above each file-list can now be used to navigate
   upwards in the directory structure.


===================================
gnome-commander 1.1.4
---------------

Bug fixes:
 * Fixed bug when selecting multiple files with shift+mouse button.
 * Stopped superfluous updates of the file-list on machines with the imon
   kernel patch applied.
 * Cleaned up the file-popup menu.
 * Fixed "File not found"-bug when browsing to the parent dir when the
   parent dir contained spaces.
 * Fixed possible async error when cancelling a xfer operation.
 * Reworked the layout tab and removed the colors tab in the options dialog.
 * Improved plugin-system.


===================================
gnome-commander 1.1.3
---------------

Bug fixes:
 * Fixed a crash that happened when moving files on a machine with a snappy
   FAM installation. This lead to that gnome-commander tried to remove the
   same file twice from a list.
 * Accessing files on mounted devices should now work better.
 * Devices without the device filename should not disappear anymore.
 * Fixed so that the feature where the terminal window stays open after
   a program has finished works more reliably.
 * Fixes bug where a new directory would appear many times
   in the same file-list until reloaded.

New features:
 * The delete confirmation can now be disabled.
 * Better error messages when a mount fails.
 * Made the calculation of a directory's total size start automaticly
   when the file prefs dialog is shown.
 * Added filter for backup files and added that and the filter for hidden
   files to the main menu for faster access.


===================================
gnome-commander 1.1.2
---------------

Bug fixes:
 * Handles non-utf8 filenames much better.
 * Removed unsafe uri creation.

New features:
 * There are now three ways to show with file-extensions.


===================================
gnome-commander 1.1.1
---------------

Bug fixes:
 * Stopped showing the file extension in both the name column and the ext column.
 * Fixed crashes that happened when browsing directories.
 * Fixed update problems when copying and moving files.
 * The connection combo boxes should now show the correct connection as
   selected all the time.
 * Removed some bugs related to selecting files using the keyboard.
 * Fixed the edit mime-types feature.

New features:
 * Added a button to change the default mime-app in the file-props dialog.


===================================
gnome-commander 1.1.0
---------------

New features:
 * SMB browsing
 * Plugins
 * Major rewrite of alot of code


